<?php

# $Id: survey_export_csv.inc,v 1.5 2002/04/28 20:43:04 jimmerman Exp $

// Written by James Flemer
// <jflemer@acm.jhu.edu>

/* {{{ proto array survey_generate_csv(int survey_id)
	Exports the results of a survey to an array.
	*/
function survey_generate_csv($sid,$idcurso="",$idmodulo="",$download_full="",$limit="",$offset="",$exportar_con_codigos=0) {
  
  
	$output = array();
	$columns = array();
	$types = array();
	$arr = array();
	
	$id_to_csv_map = array(
		'0',	// 0: unused
		'1',	// 1: bool -> boolean
		'1',	// 2: text -> string
		'1',	// 3: essay -> string
		'1',	// 4: radio -> string
		'3',	// 5: check -> string
		'1',	// 6: dropdn -> string
		'0',	// 7: rating -> number
		'0',	// 8: rate -> number
		'1',	// 9: date -> string
		'0' 	// 10: numeric -> number
	);

	$sql = "SELECT q.id, q.name, q.type_id, q.content
		FROM question q
		WHERE q.survey_id = $sid AND
		q.deleted = 'N' AND q.type_id < 50
		ORDER BY position";
		
		
	
	$result = mysql_query($sql);
	$numcols = mysql_num_rows($result);
	while( list( $qid, $col, $type, $contenido_preg ) = mysql_fetch_row($result) ) {
		if ($type == 8 || $type==5 ) {
			/* rate */
			$sql = "SELECT CONCAT(q.name, '_', c.content)
			FROM question q, question_choice c
			WHERE q.id = $qid AND q.id = c.question_id order by c.id";
			
			if($sid==87 && $exportar_con_codigos==1) // chcm. enero 04 2010. para elproyecto de google.
			{
          	$sql = "SELECT CONCAT(q.name, '_', c.id)
			     FROM question q, question_choice c
			     WHERE q.id = $qid AND q.id = c.question_id";
      }
			$result2 = mysql_query($sql);
			$numcols += mysql_num_rows($result2) - 1;
			while( list($col) = mysql_fetch_row($result2) ) {
				$str1 = $col;
				do {
					$str2 = $str1;
					$str1 = eregi_replace(
					"(^| )(what|which|why|how|who|where|how|is|are|were|the|a|it|of|do|you|your|please|enter)[ ?]", 
					" ", $str2);
				} while ($str1 != $str2);
				$col = $str1;
				$col = strtoupper(eregi_replace(
					"[^A-Z0-9]+", "_", trim($col)));
				$col = ereg_replace('_$',"",$col);
				array_push($columns, $col);
				
        
				array_push($types, $id_to_csv_map[$type]);
			}
			mysql_free_result($result2);
		} else {
		
		  /* ********************************************************************
		CAMBIO REALIZADO POR: CARLOS H. CERON MEZA
		carceron@hotmail.com
		MAYO 03 DE 2007
		DESCRIPCION:  SI EL USUARIO PERTENECE AL GRUPO CEDDET ENTONCES NO SE EXPORTARA LA COLUMNA NU ni IDU QUE ESTN EN LA BASE DE DATOS, ESAS COLUMNAS CORRESPONDEN AL ID DEL USUARIO Y EL NOMBRE DEL USUARIO.
		**************************************************************** */
		
		if ($_SESSION["grupo"]=="Ceddet")
		    {
		    
		    
		      if (($contenido_preg!="iduser")&&($contenido_preg!="nombreuser")){
			     array_push($columns, $col);
			     array_push($types, $id_to_csv_map[$type]);
			    }
		    } //if
			  else
			  {
			  //echo $col."<br>";
           array_push($columns, $col);
			     array_push($types, $id_to_csv_map[$type]);
        } //else
		}
	}
	
	//chcm. Mayo 27 2008. Exporto el timestamp y el rid
				if ($download_full==1)
				{
          array_push($columns,"Response id");
          array_push($columns,"Fecha de respuesta");
        }
	
	mysql_free_result($result);		
	
	$num = 0;
	
	array_push($output, $columns);
	
	if($offset!="")
	 $limite=" limit $offset ";
	
  if($limit!="")
	 $limite.=" , $limit ";
	
	
		
	
  
  $sql = "SELECT id,submitted  FROM response 
		WHERE survey_id='$sid' AND complete='Y'
		ORDER BY submitted $limite";
		
	
  //chcm.  Febrero 11 2010. Si es la encuesta de Google exporta los que tienen en la pregunta MR algo
  /*if ($sid==87)
	     $sql=" SELECT a.id,a.submitted  FROM response a, response_text b, question c 
		WHERE a.survey_id='$sid' AND a.complete='Y' and b.question_id=3836 and a.id=b.response_id and b.question_id=c.id
		and b.response<>'' ORDER BY a.submitted $limite"; 
	*/	
		
		
	$result = mysql_query($sql);
	while($row = mysql_fetch_row($result)) {
		// get the response
		$response = response_select_named($sid, $row[0]);
		$submited = $row[1];
		
		//echo "<pre>";print_r($response);echo "</pre>";
		if ($idcurso!="" && $idmodulo!="")
		{//ES PARA EL CEDDET
		$ceddet=1;
		
		
		
		  if (($response["IDCURSO"]==$idcurso)&&($response["IDMODULO"]==$idmodulo))
		  {
		    $arreglo_usuarios[]=$response['IDU'];
		    $arreglo_nombre_usuarios[] = $response['NU'];
		  }
		  else{
        $arreglo_usuarios[]="";
        $arreglo_nombre_usuarios[] = "";
      }
		}
		
	 
	
		$arr = array();
		
		// merge it
		
		
		for($i = 0; $i < $numcols; $i++) {
			/*
    CHCM. JULIO 20 2007.  COMENTO EL SIGUIENTE FRAGMENTO PORQUE YA NO HAY ARREGLOS EN LAS COLUMNAS YA QUE DENTRO DE LA FUNCION response_select_named SE COLOCAN LAS RESPUETAS DE LOS CHECKBOXES EN CADA COLUMNA Y NO SE RETORNA YA UN ARRAY
    */
    /*if (isset($response[$columns[$i]]) &&
					is_array($response[$columns[$i]]))
					{ exit;
				$response[$columns[$i]] = join(',', $response[$columns[$i]]);
				
				}
			*/
      
      
			switch ($types[$i]) {
			case 2: /* special */
				break;
			case 1: /* string */
				if (isset($response[$columns[$i]])) {
					$response[$columns[$i]] = ereg_replace("[\n\t]", ' ', $response[$columns[$i]]);
					$response[$columns[$i]] = ereg_replace('"', '""', $response[$columns[$i]]);
					$response[$columns[$i]] = '"'. $response[$columns[$i]] .'"';
				} 
				/* fall through */
			case 0: /* number */
				if (isset($response[$columns[$i]]))
					array_push($arr, $response[$columns[$i]]);
				else
					array_push($arr, '');
				break;
				case 3: /* checkbox */
				if (isset($response[$columns[$i]]))
					array_push($arr, $response[$columns[$i]]);
				else
					array_push($arr, '0');
				break;
			}
		}
		
		//chcm. Mayo 27 2008.  Exporto con timestamp y rid
		if ($download_full==1)
		{
      array_push($arr,$row[0]);
      array_push($arr,$row[1]);
    }
		
    array_push($output, $arr);
	}

	/*echo sizeof($output)."<br>";
	echo sizeof($arreglo_usuarios);
	 i($output);
	 i($arreglo_usuarios);
	  */ 
	
//	echo "<pre>";print_r($output);echo "</pre>";
	/*
    CREADO POR CARLOS CERON.
    FECHA: MAYO 14 2007
    VERIFICO SI YA HAY UN REGISTRO CON EL MISMO ID DE USUARIO, DE MODULO Y 
    DE CURSO PARA NO METERLO EN EL VECTOR FINAL, ESTO ES PORQUE HAY UN REQUISITO
    QUE DICE QUE NO DEBEN HABER VALORES DUPLICADOS EN EL VECTOR FINAL
  */
  
 	
   if($ceddet==1)
   {
      $vector_resultado=array();
	    $vector_resultado[0]=$output[0]; //pongo los titulos de las preguntas
	    $tamano_arreglo_usuarios=sizeof($arreglo_usuarios);
	    $contador_aux = $tamano_arreglo_usuarios;
      
     // echo "<pre>";print_r($response);echo "</pre>";
     // echo "<pre>";print_r($output);echo "</pre>";
	    
	    $posicion_id_curso = array_search("IDCURSO",$output[0]);
	    $posicion_id_modulo =  array_search("IDMODULO",$output[0]);
	

	   
	   
	    for($i=1,$j=0;$i<=sizeof($output);$i++,$j++)
	    {
         $contador_aux--;
         
          $id_curso_output = str_replace("\"","",$output[$i][$posicion_id_curso]);
          $id_modulo_output = str_replace("\"","",$output[$i][$posicion_id_modulo]);
            
         
        
              if ($id_curso_output==$idcurso && $id_modulo_output==$idmodulo)
              {//para que verifique si es del mismo curso y modulo
                 if (sizeof($vector_resultado)==1)
                 {//solo est'a el encabezado, no debo verificar duplicados
                  
                   $vector_resultado[]=$output[$i];
                   $vector_auxiliar_usuarios[]=$arreglo_usuarios[$j];
                     
                }
                else
                {
     
                    if (!in_array($arreglo_usuarios[$j],$vector_auxiliar_usuarios))
                    {//verifico si ya est en el vector resultado para no meterlo de nuevo
                     
                                            
                            $vector_resultado[]=$output[$i];                           
                            $vector_auxiliar_usuarios[]=$arreglo_usuarios[$j];
                    }
                   else
                    {

                       if ( $arreglo_nombre_usuarios[$j]=="anonimo")
                       {//chcm. Mayo 15 2008. si el nombre de usuario es anonimo no tengo en cuenta que est'e duplicado, lo inserto
                            $vector_resultado[]=$output[$i];                           
                            $vector_auxiliar_usuarios[]=$arreglo_usuarios[$j];
                       }
                       else
                       {
                            //ya esta en el vector, no lo agregue porque es repetido
                       }
                    }
                }
              }
             
        }
      
    }// if $ceddet==1
   else  
   $vector_resultado = $output;
    //i($vector_resultado);
   mysql_free_result($result);
   //	echo "<pre>";print_r($vector_resultado);echo "</pre>";
    
   return $vector_resultado;
	
	//return $output;
}
/* }}} */

/* {{{ proto bool survey_export_csv(int survey_id, string filename)
	Exports the results of a survey to a CSV file.
	Returns true on success.
	*/
function survey_export_csv($sid, $filename, $separator) { //JS 06JUL2006 - se aade el separador 
	//$umask = umask(0777);
	$fh = fopen($filename, 'w');
	// umask($umask);
	chmod($filename, 0777);  
	if(!$fh)
		return 0;
	
	$data = survey_generate_csv($sid);
	
	foreach ($data as $row) {
		fputs($fh, join( $separator, $row) . "\n"); // JS 06JUL2006 - se aade el separador
	}
	
	fflush($fh);
	fclose($fh);
	
	return 1;
}

function obtenerValorResponse($sid,$content)
 {/*Funcion que retorna el valor del campo response de la tabla response_text
 de acuerdo al $sid y $content que pasan por parametros, se consulta en la tabla question para obtener el id de acuerdo al $sid y $content, con ese id se va a la tabla response_text y se saca el campo response.
 Creado por : CARLOS H. CERON MEZA
 FECHA: MAYO 04 2007
 Funcin creada para satisfacer requisitos de CEDDET
 */
 
    $sql = "select id from question where survey_id=$sid and content='$content'";
    $result_q = mysql_query($sql);
    $fila = mysql_fetch_array($result_q);
    $qid = $fila['id'];
    
   // echo $sql."<br>";
    $sql = "select response from response_text, response where question_id=$qid and id=response_id order by submitted asc";
    $result_r = mysql_query($sql);
    
    //echo $sql."<br><br>"; 
    $respuestas = "";
    if ($result_r) 
    while(list($response) = mysql_fetch_row($result_r))
    {
      $respuestas[] = $response; 
    }
    return $respuestas;
 }

 function i($vector)
 {
    echo "<pre>";
      print_r($vector);
    echo "</pre>";
 }
 
/* }}} */
?>
