<?php



# $Id: survey_update.inc,v 1.5 2001/12/07 01:46:30 jimmerman Exp $



// Written by James Flemer

// For eGrad2000.com

// <jflemer@acm.jhu.edu>

// <jflemer@eGrad2000.com>



if(!defined('_FUNCTION_SURVEY_UPDATE')) {

	define('_FUNCTION_SURVEY_UPDATE',TRUE);



/* {{{ proto bool survey_update(int* survey_id, string* tab, string old_tab)

   Reads current form variables from HTTP_POST_VARS.

   Returns an true on sucess, else returns false and 

   sets global $errstr with an error message. */

function survey_update(&$survey_id, &$tab, $old_tab) {

	global $_POST, $_SERVER, $errstr;



	// do not need update

	if(empty($old_tab))

		return(1);



	$f_arr = array();

	$v_arr = array();



	// new survey

	if(empty($survey_id)) {

		$_POST['name'] = eregi_replace(

			"[^A-Z0-9]+", "_", trim($_POST['name']) );

		$_POST['name'] = ereg_replace('_$',"",$_POST['name']);



		// need to fill out at least some info on 1st tab before proceeding

		if(empty($_POST['name']) || empty($_POST['title'])

				|| empty($_POST['realm'])) {

			$tab = "general";

			$errstr = _('Sorry, please fill out the name, group, and title before proceeding.');

			return(0);

		}



		// create a new survey in the database

		$fields = array('name','realm','title','subtitle','email','thank_head','thank_body','info');

		foreach($fields as $f) {

			if(isset($_POST[$f])) {

				array_push($f_arr,$f);

				array_push($v_arr,"'".XADDSLASHES($_POST[$f])."'");

			}

		}

		array_push($f_arr,'owner');

		array_push($v_arr,"'".$GLOBALS['HTTP_SESSION_VARS']['acl']['username']."'");

		$sql = "INSERT INTO survey (" . join(',',$f_arr) . ") VALUES (" . join(',',$v_arr) . ")";



		$result = @mysql_query ($sql);

		if(!$result) {

			$tab = "general";

			$errstr = _('Sorry, name already in use. Pick a new name.') .' [ ' .mysql_errno().': '.mysql_error().' ]';

			return(0);

		}



		$sql = "SELECT id FROM survey WHERE name='".  XADDSLASHES($_POST['name']) ."'";

		$result = mysql_query($sql);

		$survey_id = mysql_result($result,0,0);

		mysql_free_result($result);

		return(1);

	}



	// survey already started

	switch($old_tab) {

		// coming from the general tab ...

		case "general":

			$_POST['name'] = eregi_replace(

				"[^A-Z0-9]+", "_", trim($_POST['name']) );

			$_POST['name'] = ereg_replace('_$',"",$_POST['name']);



			if(empty($_POST['name']) || empty($_POST['title'])

					|| empty($_POST['realm'])) {

				$tab = "general";

				$errstr = _('Sorry, please fill out the name, group, and title before proceeding.');

				return(0);

			}



			$fields = array('name','realm','title','subtitle','email','thank_head','thank_body','info');

			$sql = "SELECT name FROM survey WHERE id='${survey_id}'";

			$result = mysql_query($sql);

			$name = mysql_result($result,0,0);

			mysql_free_result($result);



			// trying to change survey name

			if($name != $_POST['name']) {

				$sql = "SELECT COUNT(*) FROM survey WHERE name='" . XADDSLASHES($_POST['name']) ."'";

				$result = mysql_query($sql);

				$count = mysql_result($result,0,0);

				mysql_free_result($result);

				if($count != 0) {

					$tab = "general";

					$errstr = _('Sorry, that name is already in use.');

					return(0);

				}

			}



			// UPDATE the row in the DB with current values

			foreach($fields as $f) {

				array_push($f_arr,$f ."='" . XADDSLASHES($_POST[$f]) . "'");

			}

			$sql = "UPDATE survey SET " . join(', ',$f_arr) . " WHERE id='${survey_id}'";

			$result = mysql_query($sql);

			if(!$result) {

				$tab = "general";

				$errstr = _('Warning, error encountered.') .' [ '.mysql_errno().': '.mysql_error().' ]';

				return(0);

			}

			return(1);



		// coming from the questions tab ...

		case "questions":

			// if the question box is empty ... ignore everything else

			if(empty($_POST['content']) && empty($_POST['name']))

				return(1);

			

			if(empty($_POST['content'])) {

				$tab = 'questions';

				$dont_clear = 1;

				$errstr = _('Please enter text for this question.');

				return(0);

			}



			// constraint: fieldname must be not empty

			//   generate it from the content if empty

			//   validate/repair fieldname

			if(empty($_POST['name'])) {

				$str1 = $_POST['content'];

				do {

					$str2 = $str1;

					$str1 = eregi_replace(

					"(^| )(what|which|why|how|who|where|how|is|are|were|the|a|it|of|do|you|your|please|enter)[ ?]", 

					" ", $str2);

				} while ($str1 != $str2);

				$_POST['name'] = $str1;

			}

			$_POST['name'] = strtoupper(substr( eregi_replace(

				"[^A-Z0-9]+", "_", trim($_POST['name'])), 0, 35));

			$_POST['name'] = ereg_replace('_$',"",$_POST['name']);



			// constraint: question type required

			if(empty($_POST['type_id'])) {

				$tab = 'questions';

				$dont_clear = 1;

				$errstr= _('Sorry, you must select a type for this question.');

				return(0);

			}



			// constraint: qid must be int or empty

			if($_POST['id'] == _('New Field'))

				$qid = '';

			$qid = intval($_POST['id']);	# curr_q_id



			// constraint: can not change between question w/ answer choices and one w/o

			$has_choices = esp_type_has_choices();

			if(!empty($qid)) {

				$sql =  "SELECT Q.type_id FROM question Q WHERE Q.survey_id='${survey_id}' AND Q.id='${qid}'"; 

				$result = mysql_query($sql);

				$old_type_id = mysql_result($result,0,0);

				mysql_free_result($result);



 

				if(($has_choices[$_POST['type_id']] != $has_choices[$old_type_id]) && ($_POST['num_choices']>0 && $_POST['choice_content_1']!="")) { // trying to change between incompatible question types

					$tab = "questions";

					$_POST['type_id'] = $old_type_id;

					$dont_clear = 1;

					$errstr = _('Sorry, you cannot change between those types of question. Create a new question instead.');

					return(0);

				}

			}

			

			// constraint: length must be int

			$_POST['length']  = intval($_POST['length']) or 0;

			

			// constraint: precise must be int

			$_POST['precise'] = intval($_POST['precise']) or 0;

			

			// defaults for length field

			if(empty($_POST['length'])) {

				$arr = array(

					0,		// 0: unused

					0,		// 1: Yes/No

					20,		// 2: Text Box  (width)

					60,		// 3: Essay Box (width)

					0,		// 4: Radio Buttons

					0,		// 5: Check Boxes (minumum)

					0,		// 6: Dropdown Box (length)

					5,		// 7: Rating (# cols)

					5,		// 8: Rate (# cols)

					0,		// 9: Date

					10		// 10: Numeric (digits)

					); 

				$_POST['length'] = $arr[$_POST['type_id']];

			}



			// defaults for precision field

			if(empty($_POST['precise'])) {

				$arr = array(

					0,		// 0: unused

					0,		// 1: Yes/No

					0,		// 2: Text Box

					5,		// 3: Essay Box (height)

					10,		// 4: Radio Buttons

					0,		// 5: Check Boxes (maximum)

					0,		// 6: Dropdown Box

					0,		// 7: Rating (use N/A)

					0,		// 8: Rate (use N/A)

					0,		// 9: Date

					0		// 10: Numeric (decimal)

					); 

				$_POST['precise'] = $arr[$_POST['type_id']];

			}



			// UPDATE row in the DB for the current question

			if($qid != '') {
			
				
        
        //$fields = array('name','type_id','length','precise','required','content','html_antes_opc','html_desp_opc','html_antes_contenido','html_despues_contenido','html_despues_texto','esc_predictiva');

				//$fields = array('name','type_id','length','precise','required','content','html_antes_opc','html_desp_opc','html_antes_contenido','html_despues_contenido','html_despues_texto');
				
				//chcm.  Marzo 02 2012  Agrego la columna tipo_text segn el issue de redmine 1439 
        $fields = array('name','type_id','length','precise','required','content','html_antes_opc','html_desp_opc','html_antes_contenido','html_despues_contenido','html_despues_texto','esc_predictiva','tipo_text');

				foreach($fields as $f) {

					if(isset($_POST[$f]))
          {
						array_push($f_arr,$f."='".XADDSLASHES($_POST[$f])."'");
          }
				}

				$sql = "UPDATE question SET " . join(', ',$f_arr) . " WHERE id='${qid}'";

				



			// INSERT row in the DB for new question

			} else {

				// set the position to the end

				$sql = "SELECT MAX(position)+1 FROM question WHERE survey_id='${survey_id}'";

				$result = mysql_query($sql);

				$_POST['position'] = mysql_result($result,0,0);

				mysql_free_result($result);



				$_POST['survey_id'] = $survey_id;

        
				$fields = array('survey_id','name','type_id','length','precise','required','content','position','html_antes_opc','html_desp_opc','html_antes_contenido','html_despues_contenido','html_despues_texto','esc_predictiva');

				//$fields = array('survey_id','name','type_id','length','precise','required','content','position','html_antes_opc','html_desp_opc','html_antes_contenido','html_despues_contenido','html_despues_texto');

				foreach($fields as $f) {

					if(isset($_POST[$f])) {

						array_push($f_arr, $f);

						array_push($v_arr, "'". XADDSLASHES($_POST[$f]) ."'");

					}

				}

				$sql = "INSERT INTO question (" . join(', ',$f_arr) . ") VALUES (" . join(', ',$v_arr) .")";

				

			}

			$result = mysql_query($sql);

			

			if($qid == '')

				$qid = mysql_insert_id();

			$_POST['id'] = $qid;

			if(!$result) {

				$tab = 'questions';

				$dont_clear = 1;

				$errstr = _('Warning, error encountered.') .' [ '.mysql_errno().': '.mysql_error().' ]';

				return(0);

			}



			// UPDATE or INSERT rows for each of the question choices for this question

			if($has_choices[$_POST['type_id']]) {

				$cids = array();

				$sql = "SELECT c.id FROM question q, question_choice c WHERE q.id=c.question_id AND q.survey_id=${survey_id}";

				$result = mysql_query($sql);

				for ($i = 0; $i < mysql_num_rows($result); ++$i) {

					array_push($cids, mysql_result($result, $i, 0));

				}

				mysql_free_result($result);

				$count = 0;

				for($i=1;$i<$_POST['num_choices']+1;$i++) {

					$sql='';

					$choice_id      = intval($_POST["choice_id_${i}"]);

					$choice_content = XADDSLASHES($_POST["choice_content_${i}"]);

					$html_antes_question = XADDSLASHES($_POST["html_antes_question_${i}"]);

					$html_despues_question = XADDSLASHES($_POST["html_despues_question_${i}"]);

					// each of the submitted choices

					if($choice_id=='' && $choice_content!='') {

						// insert (new)

						$sql = "INSERT INTO question_choice (question_id,content,html_antes_question,html_despues_question) VALUES ('${qid}','${choice_content}','${html_antes_question}','${html_despues_question}')";

						++$count;

					} elseif($choice_id!='' && $choice_content=='') {

						// delete (old)

						$sql = "DELETE FROM question_choice WHERE id='${choice_id}'";

					} elseif($choice_id!='' && $choice_content!='' && in_array($choice_id, $cids)) {

						// update (old)

						$sql = "UPDATE question_choice SET content='${choice_content}',html_antes_question='${html_antes_question}',html_despues_question='${html_despues_question}' WHERE id='${choice_id}'";

						++$count;

					}
					
					
					
					
					
					

					if($sql != '') {

						$result = mysql_query($sql);

						if(!$result) {

							$tab = 'questions';

							$dont_clear = 1;

							$errstr = _('Warning, error encountered.') .' [ '.mysql_errno().': '.mysql_error().' ]';

							return(0);

						}

					}

				}

				if(!$count && !isset($_POST['extra_choices'])) {

					$tab = 'questions';

					$dont_clear = 1;

					$errstr = _('Sorry, you need at least one answer option for this question type.') .

						' [ '. _('ID') .': '. $_POST['type_id'] .' ]';

					return(0);

				}

			}
			
			include_once('survey_update_cabeceras.inc');

			return(1);



		case "preview":

			// can not change anything here yet, so no need to update DB.

			return(1);



		case "order":

			// it updates the DB itself

			return(1);

	}

	return(1);

}

/* }}} */



} // end _FUNCTION_SURVEY_UPDATE

?>
