<?php



# $Id: esphtml.results.inc,v 1.6 2002/04/28 20:43:40 jimmerman Exp $



// Written by James Flemer

// <jflemer@acm.jhu.edu>



// void		mkrespercent(int[char*] counts, int total, bool showTotals);

// void		mkresrank(int[char*] counts, int total, bool showTotals);

// void		mkrescount(int[char*] counts, int total, bool showTotals);

// void		mkreslist(int[char*] counts, int total, bool showTotals);

// void		mkresavg(int[char*] counts, int total, bool showTotals);



if(!defined('_LIB_ESPHTML_RESULTS')) {

	define('_LIB_ESPHTML_RESULTS',TRUE);



/* {{{ proto void mkrespercent(array weights, int total, int precision, bool show_totals)

  Builds HTML showing PERCENTAGE results. */

function mkrespercent($counts,$total,$precision,$showTotals) {

	$i=0;

	$bg='';

?>

<table width="90%" border="0">

<?php

	while(list($content,$num) = each($counts)) {

		if($num>0) { $percent = $num/$total*100.0; }

		else { $percent = 0; }

		if($percent > 100) { $percent = 100; }



		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td><?php echo($content); ?></td>

		<td align="left">

<?php

		if($num) {

			echo("&nbsp;<img src=\"" .$GLOBALS['ESPCONFIG']['image_path'] ."/hbar_l.gif\" height=9 width=4>");

			printf("<img src=\"" .$GLOBALS['ESPCONFIG']['image_path'] ."/hbar.gif\" height=9 width=%d>",$percent*2);

			echo("<img src=\"" .$GLOBALS['ESPCONFIG']['image_path'] ."/hbar_r.gif\" height=9 width=4>");

			printf("&nbsp;%.${precision}f%%",$percent);

		}

?></td>

		<td align="right">(<?php echo($num); ?>)</td>

	</tr>

<?php

		$i += $num;

	} // end while

	if($showTotals) {

		if($i>0) { $percent = $i/$total*100.0; }

		else { $percent = 0; }

		if($percent > 100) { $percent = 100; }



		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td><b><?php echo(_('TOTAL')); ?></b></td>

		<td width="40%"><b>&nbsp;<?php

			echo("<img src=\"" .$GLOBALS['ESPCONFIG']['image_path'] ."/hbar_l.gif\" height=9 width=4>");

			printf("<img src=\"" .$GLOBALS['ESPCONFIG']['image_path'] ."/hbar.gif\" height=9 width=%d>",$percent*2);

			echo("<img src=\"" .$GLOBALS['ESPCONFIG']['image_path'] ."/hbar_r.gif\" height=9 width=4>");

			printf("&nbsp;%.${precision}f%%",$percent); ?></b></td>

		<td width="10%" align="right"><b><?php echo($total); ?></b></td>

	</tr>

<?php } ?>

</table>

<?php

}

/* }}} */



	

/* {{{ proto void mkresrank(array weights, int total, int precision, bool show_totals) 

   Builds HTML showing RANK results. */

function mkresrank($counts,$total,$precision,$showTotals) {

	$bg='';

?>

<table border="0">

	<tr>

		<td align="right"><b><?php echo(_('Rank')); ?></b></td>

		<td>&nbsp;</td>

		<td>&nbsp;</td>

		<td>&nbsp;</td>

	</tr>

<?php

	arsort($counts);

	$i=0; $pt=0;

	while(list($content,$num) = each($counts)) {

		if($num)

			$p = $num/$total*100.0;

		else

			$p = 0;

		$pt += $p;



		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td align="right"><b><?php echo(++$i); ?></b></td>

		<td><?php echo($content); ?></td>

		<td align="right" width="60"><?php if($p) printf("%.${precision}f%%",$p); ?></td>

		<td align="right" width="60">(<?php echo($num); ?>)</td>

	</tr>

<?php

	} // end while

	if($showTotals) {

		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td colspan=2 align="left"><b><?php echo(_('TOTAL')); ?></b></td>

		<td align="right"><b><?php printf("%.${precision}f%%",$pt); ?></b></td>

		<td align="right"><b><?php echo($total); ?></b></td>

	</tr>

<?php } ?>

</table>

<?php

}

/* }}} */



/* {{{ proto void mkrescount(array weights, int total, int precision, bool show_totals) 

   Builds HTML showing COUNT results. */

function mkrescount($counts,$total,$precision,$showTotals) {

	$i=0;

?>

<table width="90%" border="0">

<?php

	while(list($content,$num) = each($counts)) {

		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td><?php echo($content); ?></td>

		<td align="right" width="60"><?php echo($num); ?></td>

		<td align="right" width="60">(<?php if($num) printf("%.${precision}f",$num/$total*100.0); ?>%)</td>

	</tr>

<?php

		$i += $num;

	} // end while

	if($showTotals) {

		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<td><b><?php echo(_('TOTAL')); ?></b></td>

		<td align="right"><b><?php echo($total); ?></b></td>

		<td align="right"><b>(<?php if($i) printf("%.${precision}f",$i/$total*100.0); ?>%)</b></td>

	</tr>

<?php	} ?>

</table>

<?php

}

/* }}} */



/* {{{ proto void mkreslist(array weights, int total, int precision, bool show_totals) 

	Builds HTML showing LIST results. */

function mkreslist($counts,$total,$precision,$showTotals) {

	if($total==0)	return;

	$bg='';

?>

<table width="90%" border="0" cellpadding="1">

	<tr><th align="left"><?php echo(_('#')); ?></th><th><?php echo(_('Respuesta/Response')); ?></th></tr>

<?php

	while(list($text,$num) = each($counts)) {

		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

		echo("<tr bgcolor=\"$bg\"><th align=\"left\" valign=\"top\">$num</th><td>$text</td></tr>\n");

	}

?>

</table>

<?php

}

/* }}} */



/* {{{ proto void mkresavg(array weights, int total, int precision, bool show_totals) 

	Builds HTML showing AVG results. */

function mkresavg($counts,$total,$precision,$showTotals,$length,$question_id="") {



	global $desplazamiento; //JS para el desplazamiento de la escala

	if (!$length)

		$length = 5;

	$width = 200 / $length;
	
	
  
 

?>

<table border=0>
<tr><td valign=top>
<table border="0" cellspacing="0" cellpadding="0">

	<tr>

		<td></td>

		<td align="center" colspan="<?php echo($length+3); ?>"><?php echo(_('Average rank')); ?></td>

	</tr>
	
	<tr>
	
	<tr>
	<?
	
   	  //chcm. junio 11 2008. Averiguo los titulos de las cabeceras. 
      $sql_cabeceras = "select content from cabeceras_rate where question_id=$question_id";
      $resultado_cabeceras = mysql_query($sql_cabeceras);
      $contenidos_cabeceras=array();
      
      //el siguiente contador es para que no se agregue la primera opcion de las columnas rate porque
      //esta lleva ESPACIO EN BLANCO o texto que va antes de las columnas (al lado izquierdo)
      $contador_aux=0;
      while($row = mysql_fetch_assoc($resultado_cabeceras) )
      {
      
          if ($contador_aux>0)
            $contenidos_cabeceras[]=$row['content'];
          $contador_aux++;
      }



		for ($i = 0; $i <= $length+2; $i++ )
    //hago este ciclo para dejar el espacio necesario para colocar los titulos de los encabezados encima de las graficas
				echo "<td>&nbsp;</td>";
	?>
	<td align=right>
      <table width=300 align=right border=0>
      <tr>
      <?
        for ($i=0;$i<$length+1;$i++)
        {
          echo "<td>{$contenidos_cabeceras[$i]}</td>";
        }
        
      ?>
      </tr>
      </table>
  
  </td>
	</tr>

	<tr>

		<td>
      
    </td>

<!-- JS version anterior a 02/07/03

		<?php

			for ($i = 0; $i < $length; )

				echo( "<td align=\"right\" width=\"$width\">". ++$i ."</td>\n");

		?>

-->



		<?php

			for ($i = 1+$desplazamiento; $i-1 < $length; $i++)

				echo( "<td align=\"right\" width=\"$width\">". $i ."</td>\n");

		?>

		<td width="20"></td>

		<td></td>

	</tr>

<?php 

//chcm. junio 05 2008. Averiguo cuantas personas respondieron por cada opcion
$sql ="select id,content from question_choice where question_id=$question_id";

$resultado = mysql_query($sql);
while($row = mysql_fetch_array($resultado))
{
  
  $contenido = strip_tags($row['content']);
  for ($i=1;$i<=$length;$i++)
  {
      
      $sql_rank = "select count(rank) as conteo from response_rank where question_id=$question_id and choice_id={$row['id']} and rank=$i";
      
      $resultado_rank = mysql_query($sql_rank);
      while($row_rank = mysql_fetch_array($resultado_rank))
      {
          $contents[$contenido][$i] = $row_rank['conteo'];
      }
  }
}
/*
echo "<pre>";
print_r($contents);
echo "</pre>";
*/

  $contenidos_cabeceras = implode(",",$contenidos_cabeceras);
  

	while(list($content,$avg) = each($counts)) {

		if($bg != $GLOBALS['ESPCONFIG']['bgalt_color1'])

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color1'];

		else

			$bg = $GLOBALS['ESPCONFIG']['bgalt_color2'];

?>

	<tr bgcolor="<?php echo($bg); ?>">

		<!-- JS before 09NOV2004		<td align="right"><?php echo($content); ?>&nbsp;</td> -->

		<td align="left"><?php 

					$textocap = explode("<tr>",$content); 

					if ($textocap[1]) 
					 {
             $contenido = strip_tags($textocap[1]);
						 echo $contenido;
				   }
             

					else
          {
						$contenido = strip_tags($textocap[0]);
            echo $contenido; 
          }
					// JS 09NOV2004 esto lo que hace es filtrar la guarradas que meto en las preguntas de rank para poner nombres a las columnas

				  ?>&nbsp;</td>

		

		<td align="left" width="220" colspan="<?php echo($length+1); ?>">

<?php

		if($avg) {

			echo('<img src="'. $GLOBALS['ESPCONFIG']['image_path'] .'/hbar_l.gif" height="9" width="4">');

			if (($j = $avg * $width - 11) > 0)

				printf('<img src="'. $GLOBALS['ESPCONFIG']['image_path'] .'/hbar.gif" height="9" width="%d">', $j);

			echo('<img src="'. $GLOBALS['ESPCONFIG']['image_path'] .'/hbar_r.gif" height="9" width="4">');

		}

      $datay=$contents[$contenido];
      $datay = implode(",",$datay);
?>

		</td>

		<td align="center" width="60">(<?php printf("%.${precision}f",$avg+$desplazamiento); ?>)</td>
		
		<td width=300 align=center><img src='<?global $ruta_imagen_graficos;
    echo $ruta_imagen_graficos?>/graficosBarrasRateScale.php?datay=<? echo $datay?>&contenidos_cabeceras=<?echo $contenidos_cabeceras?>&width=350&height=80' width=350 height=80></td>

	</tr>

<?php

	} // end while

?>

</table>

</td>

  <td width=100>
    &nbsp;
  </td>
<td> <!-- chcm. junio 5 2008. Tabla para poner los graficos de barras en rate scale -->


</td>
</tr>
</table>

<?php

}

/* }}} */



} // end _LIB_ESPHTML_RESULTS

?>
